. demo gui file maintenance program
. tabs are assumed to be 6:5
. menu for gui demo program
menu1	init "MENU=M1,":
		"MAIN=100:File,":
			"SUBMENU=110:Open,":
				"ITEM=111:Customer,":
				"ITEM=112:Vendor,":
			"ENDSUBMENU,":
			"ITEM=151:Close, KEY=^W,":
			"LINE,":
			"ITEM=181:Page Setup...,":
			"ITEM=182:Print..., KEY=^P,":
			"LINE,":
			"ITEM=199:Quit, KEY=^Q,":
		"MAIN=200:Edit,":
			"ITEM=201:Cut, KEY=^X,":
			"ITEM=202:Copy, KEY=^C,":
			"ITEM=203:Paste, KEY=^V,":
			"LINE,":
			"ITEM=204:Add Record, KEY=^A,":
			"ITEM=205:Delete Record, KEY=^D,":
			"ITEM=206:Save Changes to Record, KEY=^S,":
			"ITEM=207:Don't Save Changes, KEY=^Z,":
		"MAIN=300:Get,":
			"ITEM=301:Find..., KEY=^F,":
			"ITEM=302:Next, KEY=^N,":
			"ITEM=303:Previous, KEY=^B,":
			"ITEM=304:Set Index, KEY=^G,":
			"LINE,":
			"ITEM=321:Select..., KEY=^L,":
			"ITEM=322:Next Selected, KEY=^K,":
			"ITEM=323:Previous Selected, KEY=^J"

. panel for gui demo program
panel1	init "PANEL=P1,":
		"H=11, V=11, TABGROUP=460:300,":
			"TAB=1000:Page 1,":
				"H=9, V=9, TEXT=Customer Number,":
				"H=145, V=5, EDIT=1::72,":
				"H=9, V=33, TEXT=Name,":
				"H=145, V=29, EDIT=2::200,":
				"H=9, V=57, TEXT=Address,":
				"H=145, V=53, EDIT=3::200,":
				"H=145, V=77, EDIT=4::200,":
				"H=9, V=105, TEXT=City\, State\, Zip,":
				"H=145, V=101, EDIT=5::96,":
				"H=249, V=101, EDIT=6::32,":
				"H=289, V=101, EDIT=7::60,":
				"H=9, V=129, TEXT=Contact Person,":
				"H=145, V=125, EDIT=8::200,":
				"H=9, V=153, TEXT=Contact Phone,":
				"H=145, V=149, FEDIT=9:999-999-9999::122,":
				"H=9, V=177, TEXT=Customer Type,":
				"H=145, V=177, DROPBOX=10:145:96, INSERTORDER,":
				"H=9, V=201, CHECKBOX=11:Tax Exempt,":
			"TAB=2000:Page 2,":
				"H=25, V=9, TEXT=Catalogs,":
				"H=9, V=29, LISTBOX=12:220:100, INSERTORDER,":
				"H=267, V=27, PUSHBUTTON=13:Add:72:24,":
				"H=267, V=67, PUSHBUTTON=14:Delete:72:24,":
				"H=25, V=145, TEXT=Comments,":
				"H=9, V=163, MEDIT=15::410:86,":
		"TABGROUPEND"

. window, menu and panel variables
windev1	device
mnures1	resource
pnlres1	resource
clipboard device

. main message queue variable
msgs		queue entries=256, size=256

. message that appears on message queue
msg		record
name		char 8
func		char 4
item		char 5
data		char 239
		recordend

. flags the identify the primary state of the program
fileflag		int 1		. value is 1 if file is open
oldrecflag	int 1		. value is 1 if a record from file is displayed
newrecflag	int 1		. value is 1 if a new record is displayed
chgrecflag	int 1		. value is 1 if changes have been made to record
fieldsflag	int 1		. value is 1 if fields are available
pasteflag		int 1		. value is 1 if there is text on the clipboard

. work variables
n		int 3
work		char 80
catalog	char 30
catalogcount int 3
selectedtext char 300
selectedfield char 2

. customer file variables
custfile	ifile fixed=772, keylen=8
custkey	char 8
cust		record
number	char 8
name		char 30
address1	char 30
address2	char 30
city		char 15
state	char 2
zip		char 10
contact	char 30
phone	char 15
type		char 1
taxexempt	char 1
catalogs	char 30[10]
comments	char 300
		recordend

. start of program

. display window, prepare panel and menu, link them to msg queue and show them
	prep windev1, "window=W1, size=480:320, title=Demo GUI Program"
	prep mnures1, menu1
	prep pnlres1, panel1
	link windev1, msgs
	link mnures1, msgs
	link pnlres1, msgs
	call menusettings
	call fieldsoff
	change pnlres1, "insertafter10"
	change pnlres1, "insert10"; "Consumer"
	change pnlres1, "insert10"; "Retailer"
	change pnlres1, "insert10"; "Wholesaler"
	change pnlres1, "insert10"; "Other"
	change pnlres1, "insertafter12"
	change pnlres1, "itemon"
	change pnlres1, "focuson"
	show mnures1, windev1
	show pnlres1, windev1
	open clipboard, "clipboard"
	load work from clipboard
	if (work = "")
		set pasteflag
	endif

. message dispatch
msgloop
	wait msgs
	get msgs; msg
. uncomment the next line to display messages in a separate window
.	display msg
	chop msg.name to msg.name
	goto menu1msg if (msg.name = "M1")
	goto panel1msg if (msg.name = "P1")
	goto window1msg if (msg.name = "W1")
	goto msgloop

. handle messages sent to window device
window1msg
	goto quit if (msg.func = "CLOS")
	goto msgloop

. handle messages sent to menu resource
menu1msg
	goto msgloop if (msg.func != "MENU")
	squeeze msg.item to msg.item
	switch msg.item
	case "111"
		call opencust
	case "112"
		call openvendor
	case "151"
		call close
	case "181"
		call printsetup
	case "182"
		call print
	case "199"
		goto quit
	case "201"
		call cut
	case "202"
		call copy
	case "203"
		call paste
	case "204"
		call addrecord
	case "205"
		call deleterecord
	case "206"
		call saverecord
	case "207"
		call cancelrecord
	case "301"
		call find
	case "302"
		call next
	case "303"
		call previous
	case "304"
		call setindex
	case "321"
		call select
	case "322"
		call selectnext
	case "323"
		call selectprevious
	endswitch
	goto msgloop

. handle message sent to panel1 resource
panel1msg
	squeeze msg.item to msg.item
	if (msg.func = "ITEM")
		switch msg.item
		case "1"
			move msg.data to cust.number
		case "2"
			move msg.data to cust.name
		case "3"
			move msg.data to cust.address1
		case "4"
			move msg.data to cust.address2
		case "5"
			move msg.data to cust.city
		case "6"
			move msg.data to cust.state
		case "7"
			move msg.data to cust.zip
		case "8"
			move msg.data to cust.contact
		case "9"
			move msg.data to cust.phone
		case "10"
			move msg.data to cust.type
		case "11"
			move msg.data to cust.taxexempt
		case "15"
			move msg.data to cust.comments
		default
			goto msgloop
		endswitch
		set chgrecflag
		call menusettings
	else if (msg.func = "PUSH")
		if (msg.item = "13")
			call fielddialog with "Add catalog", catalog
			if (not over)
				change pnlres1, "insert12"; catalog
				add 1 to catalogcount
				move catalog to cust.catalogs[catalogcount]
				set chgrecflag
				call menusettings
			endif
		else if (msg.item = "14")
			query pnlres1, "status12"; catalog
			change pnlres1, "delete12"; catalog
			for n from 1 to catalogcount
				break if (catalog = cust.catalogs[n])
			repeat
			loop
				break if (n > catalogcount)
				move cust.catalogs[n + 1] to cust.catalogs[n]
				add 1 to n
			repeat
			set chgrecflag
			call menusettings
		endif
	else if (msg.func = "ESEL")
		move msg.data to selectedtext
		if (selectedtext = "")
			change mnures1, "gray201"
			change mnures1, "gray202"
		else
			change mnures1, "available201"
			change mnures1, "available202"
		endif
		move msg.item to selectedfield
	else if (msg.func = "FOCS")
		move msg.item to selectedfield
		if (msg.item = "10" or msg.item = "11" or msg.item = "12" or msg.item = "13" or msg.item = "14")
			change mnures1, "gray201"
			change mnures1, "gray202"
		endif	
	endif
	goto msgloop

. open customer file
opencust
	call checksave
	call opencustomerfile
	set fileflag
	call menusettings
	return

. open vendor file
openvendor
	call notsupported
	return

. close file
close
 	call closefile
	clear fileflag
	call menusettings
	return

. printer setup
printsetup
	call notsupported
	return

. print
print
	call notsupported
	return

. quit
quit
	call checksave
	call closefile
	stop

. cut to clipboard
cut
	store selectedtext to clipboard
	change pnlres1, ("paste" + selectedfield)
	if (not pasteflag)
		change mnures1, "available203"
		set pasteflag
	endif
	return

. copy to clipboard
copy
	store selectedtext to clipboard
	if (not pasteflag)
		change mnures1, "available203"
		set pasteflag
	endif
	return

. paste from clipboard
paste
	load selectedtext from clipboard
	change pnlres1, ("paste" + selectedfield); selectedtext
	return

. add a new record
addrecord
	call checksave
	set newrecflag
	call menusettings
	clear cust
	call displayfields
	return

. delete the currently displayed record
deleterecord
	return if (not oldrecflag)
	call okdialog with "OK to delete the record?"
	return if over
	call deletecust
	call erasefields
	clear oldrecflag, chgrecflag
	call menusettings
	return

. save the changed record
saverecord
	return if (not chgrecflag)
	if (newrecflag)
		call writecust
		clear newrecflag
		set oldrecflag
	else if (oldrecflag)
		call updatecust
	endif
	clear chgrecflag
	call menusettings
	return

. cancel the change to record
cancelrecord
	return if (not chgrecflag)
	if (newrecflag)
		call erasefields
		clear newrecflag
	else if (oldrecflag)
		call readcust
		call displayfields
	endif
	clear chgrecflag
	call menusettings
	return

. find a record
find
	call checksave
	if (oldrecflag)
		call erasefields
		clear oldrecflag
	endif
	call fielddialog with "Customer number", custkey
	return if over
	move (custkey + "        ") to custkey
	call readcust
	if (over)
		call msgdialog with "Record not found"
	else
		call displayfields
		set oldrecflag
	endif
	call menusettings
	return

. get the next record
next
	call checksave
	call readkscust
	if (over)
		call erasefields
		clear oldrecflag
		call msgdialog with "No more records"
	else
		call displayfields
		set oldrecflag
	endif
	call menusettings
	return

. get the previous record
previous
	call checksave
	call readkpcust
	if (over)
		call erasefields
		clear oldrecflag
		call msgdialog with "No previous records"
	else
		call displayfields
		set oldrecflag
	endif
	call menusettings
	return

. set the index (for files with multiple indexes)
setindex
	call notsupported
	return

. select a record (for files with an aim index)
select
	call notsupported
	return

. get next selected record
selectnext
	call notsupported
	return

. get previous selected record
selectprevious
	call notsupported
	return

. see if user wants to save the record if it has been changed
checksave
	return if (not chgrecflag)
	call okdialog with "OK to save changes?"
	if (over)
		if (newrecflag)
			call erasefields
			clear newrecflag
		else if (oldrecflag)
			call readcust
			call displayfields
		endif
	else
		if (newrecflag)
			call writecust
			clear newrecflag
			set oldrecflag
		else if (oldrecflag)
			call updatecust
		endif
	endif
	clear chgrecflag
	call menusettings
	return

. display a record
displayfields
	change pnlres1, "text1"; cust.number
	change pnlres1, "text2"; cust.name
	change pnlres1, "text3"; cust.address1
	change pnlres1, "text4"; cust.address2
	change pnlres1, "text5"; cust.city
	change pnlres1, "text6"; cust.state
	change pnlres1, "text7"; cust.zip
	change pnlres1, "text8"; cust.contact
	change pnlres1, "text9"; cust.phone
	if (cust.type = "C")
		change pnlres1, "locateline10"; "1"
	else if (cust.type = "R")
		change pnlres1, "locateline10"; "2"
	else if (cust.type = "W")
		change pnlres1, "locateline10"; "3"
	else
		change pnlres1, "locateline10"; "4"
	endif
	if (cust.taxexempt = "Y")
		change pnlres1, "mark11"
	else
		change pnlres1, "unmark11"
	endif
	for n from 1 to 10
		squeeze cust.catalogs[n] to work
		continue if (work = "")
		change pnlres1, "insert12"; work
	repeat
	change pnlres1, "text15"; cust.comments
	call fieldsflag
	change pnlres1, "focus1"
	return

. erase a record
erasefields
	change pnlres1, "erase1"
	change pnlres1, "erase2"
	change pnlres1, "erase3"
	change pnlres1, "erase4"
	change pnlres1, "erase5"
	change pnlres1, "erase6"
	change pnlres1, "erase7"
	change pnlres1, "erase8"
	change pnlres1, "erase9"
	change pnlres1, "locateline10"; "1"
	change pnlres1, "unmark11"
	change pnlres1, "erase12"
	change pnlres1, "erase15"
	call fieldsoff
	return

. set the availability of menu items
menusettings
xfileflag		int "-1"
xoldrecflag	int "-1"
xnewrecflag	int "-1"
xchgrecflag	int "-1"

	if (fileflag != xfileflag)
		move fileflag to xfileflag
		if (fileflag)
			change mnures1, "available151"
			change mnures1, "available204"
			change mnures1, "available301"
			change mnures1, "available302"
			change mnures1, "available303"
			change mnures1, "available304"
			change mnures1, "available321"
			change mnures1, "available322"
			change mnures1, "available323"
		else
			change mnures1, "gray151"
			change mnures1, "gray182"
			change mnures1, "gray201"
			change mnures1, "gray202"
			change mnures1, "gray203"
			change mnures1, "gray204"
			change mnures1, "gray205"
			change mnures1, "gray206"
			change mnures1, "gray207"
			change mnures1, "gray301"
			change mnures1, "gray302"
			change mnures1, "gray303"
			change mnures1, "gray304"
			change mnures1, "gray321"
			change mnures1, "gray322"
			change mnures1, "gray323"
		endif
	endif
	if (oldrecflag != xoldrecflag)
		move oldrecflag to xoldrecflag
		if (oldrecflag)
			change mnures1, "available182"
			change mnures1, "available205"
			if (pasteflag)
				change mnures1, "available203"
			endif
		else
			change mnures1, "gray182"
			change mnures1, "gray205"
			if (pasteflag)
				change mnures1, "gray203"
			endif
		endif	
	endif
	if (newrecflag != xnewrecflag)
		move newrecflag to xnewrecflag
		if (newrecflag)
			change mnures1, "available207"
			if (pasteflag)
				change mnures1, "available203"
			endif
		else
			change mnures1, "gray207"
			if (pasteflag)
				change mnures1, "gray203"
			endif
		endif
	endif
	if (chgrecflag != xchgrecflag)
		move chgrecflag to xchgrecflag
		if (chgrecflag)
			change mnures1, "available206"
			change mnures1, "available207"
		else
			change mnures1, "gray206"
			change mnures1, "gray207"
		endif
	endif
	return

. turn fields on
fieldsflag
	return if (fieldsflag)
	set fieldsflag
	change pnlres1, "available1"
	change pnlres1, "available2"
	change pnlres1, "available3"
	change pnlres1, "available4"
	change pnlres1, "available5"
	change pnlres1, "available6"
	change pnlres1, "available7"
	change pnlres1, "available8"
	change pnlres1, "available9"
	change pnlres1, "available10"
	change pnlres1, "available11"
	change pnlres1, "available12"
	change pnlres1, "available13"
	change pnlres1, "available14"
	change pnlres1, "available15"
	return

. turn fields off
fieldsoff
	clear fieldsflag
	change pnlres1, "gray1"
	change pnlres1, "gray2"
	change pnlres1, "gray3"
	change pnlres1, "gray4"
	change pnlres1, "gray5"
	change pnlres1, "gray6"
	change pnlres1, "gray7"
	change pnlres1, "gray8"
	change pnlres1, "gray9"
	change pnlres1, "gray10"
	change pnlres1, "gray11"
	change pnlres1, "gray12"
	change pnlres1, "gray13"
	change pnlres1, "gray14"
	change pnlres1, "gray15"
	return

. the following code deals exclusively with files
. open customer file
opencustomerfile
	open custfile, "customer"
	return

. close customer or vendor file
closefile
	close custfile
	return

. read and write routines
readcust
	read custfile, custkey; cust
	return if not over
	clear custkey
	return
readkscust
	clear custkey
	readks custfile; cust
	return if over
	move cust.number to custkey
	return
readkpcust
	clear custkey
	readkp custfile; cust
	return if over
	move cust.number to custkey
	return
writecust
	move (cust.number + "        ") to custkey
	write custfile, custkey; cust
	return
updatecust
	move (cust.number + "        ") to cust.number
	update custfile; cust
	if (cust.number != custkey)
		deletek custfile, custkey
		move cust.number to custkey
		insert custfile, custkey
	endif
	return
deletecust
	delete custfile, custkey
	clear custkey
	return

. open vendor file
openvendorfile
	call notsupported
	return

. not supported dialog
notsupported
	call msgdialog with "Function is not supported!"
	return

. variables common to next two dialogs
dlgmsgs	queue
dlgmsg	char 32
dlgres	resource
dlgdef	char 200
dlgtext	char @

. display a message dialog
msgdialog lroutine dlgtext
	clear dlgdef
	append "DIALOG=D1, SIZE=200:100, H=1, V=20, CTEXT=" to dlgdef
	append dlgtext to dlgdef
	append ":200, H=60, V=60, PUSHBUTTON=99:Continue:80:24" to dlgdef
	reset dlgdef
	prep dlgres, dlgdef
	empty msgs
 	link dlgres, dlgmsgs
	show dlgres, windev1
	loop
		fill " " in dlgmsg
		wait dlgmsgs
		get dlgmsgs; dlgmsg
		reset dlgmsg to 9
		cmatch "P" to dlgmsg
		break if equal
	repeat
	hide dlgres
	unlink dlgres
	close dlgres
	return
	endroutine

. display an OK and Cancel dialog
okdialog lroutine dlgtext
	clear dlgdef
	append "DIALOG=D2, SIZE=200:100, H=1, V=20, CTEXT=" to dlgdef
	append dlgtext to dlgdef
	append ":200, H=24, V=60, PUSHBUTTON=98:OK:64:24," to dlgdef
	append "H=112, V=60, PUSHBUTTON=99:Cancel:64:24" to dlgdef
	reset dlgdef
	prep dlgres, dlgdef
	empty msgs
 	link dlgres, dlgmsgs
	show dlgres, windev1
	loop
		fill " " in dlgmsg
		wait dlgmsgs
		get dlgmsgs; dlgmsg
		reset dlgmsg to 9
		cmatch "P" to dlgmsg
		break if equal
	repeat
	hide dlgres
	unlink dlgres
	close dlgres
	reset dlgmsg to 17
	setflag not over
	cmatch "8" to dlgmsg
	return if equal
	setflag over
	return
 
. display a dialog the inputs a field
fielddialog lroutine dlgtext, dlgfield
dlgfield	char @
	clear dlgdef
	append "DIALOG=D3, SIZE=300:100, H=10, V=20, TEXT=" to dlgdef
	append dlgtext to dlgdef
	append ", H=150, V=20, EDIT=91::140," to dlgdef
	append "H=24, V=60, PUSHBUTTON=98:OK:64:24, " to dlgdef
	append "H=112, V=60, PUSHBUTTON=99:Cancel:64:24" to dlgdef
	reset dlgdef
	prep dlgres, dlgdef
	empty msgs
 	link dlgres, dlgmsgs
	show dlgres, windev1
	loop
		fill " " in dlgmsg
		wait dlgmsgs
		get dlgmsgs; dlgmsg
		reset dlgmsg to 9
		cmatch "P" to dlgmsg
		break if equal
	repeat
	hide dlgres
	unlink dlgres
	reset dlgmsg to 17
	cmatch "8" to dlgmsg
	if equal
		query dlgres, "status91"; dlgfield
		setflag not over
	else
		setflag over
	endif
	close dlgres
	return
